// TsStream.h: TSXg[bp[NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(_TSSTREAM_H_)
#define _TSSTREAM_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MediaData.h"


/////////////////////////////////////////////////////////////////////////////
// TSpPbgyC[hۉNX
/////////////////////////////////////////////////////////////////////////////
class CTsPayload
{
public:
	CTsPayload();
	CTsPayload(const CTsPayload &Operand);
	
	CTsPayload & operator = (const CTsPayload &Operand);

	BYTE *m_pHexData;						// oCif[^
	BYTE m_byDataLength;					// oCif[^
};


/////////////////////////////////////////////////////////////////////////////
// TSpPbgۉNX
/////////////////////////////////////////////////////////////////////////////

class CTsPacket : public CMediaData
{
public:
	CTsPacket();
	CTsPacket(const BYTE *pHexData);
	CTsPacket(const CTsPacket &Operand);
	
	CTsPacket & operator = (const CTsPacket &Operand);

	void ParseHeader(void);
	const bool CheckPacket(BYTE *pContinuityCounter = NULL);

	const WORD GetPID(void) const;
	const bool HaveAdaptationField(void) const;
	const bool HavePayload(void) const;
	const BYTE GetUnitStartPostion(void) const;

	struct TAG_TSPACKETHEADER{
		BYTE bySyncByte;					// oCg
		bool bTransportErrorIndicator;		// gX|[gG[CWP[^
		bool bPayloadUnitStartIndicator;	// yC[hjbgJnCWP[^
		bool TransportPriority;				// gX|[gDx
		WORD wPID;							// PID
		BYTE byTransportScramblingCtrl;		// gX|[gXNu
		BYTE byAdaptationFieldCtrl;			// A_ve[VtB[h
		BYTE byContinuityCounter;			// AwW
		} m_Header;

	struct TAG_ADAPTFIELDHEADER{
		BYTE byAdaptationFieldLength;		// A_ve[VtB[h
		bool bDiscontinuityIndicator;		// ACWP[^
		bool bRamdomAccessIndicator;		// _ANZXCWP[^
		bool bEsPriorityIndicator;			// ESvCIeBCWP[^
		BYTE byFiveFlags;					// 5tO
		const BYTE *pOptionField;			// IvVtB[h
		} m_AdaptationField;

	CTsPayload m_Payload;					// yC[h
};


/////////////////////////////////////////////////////////////////////////////
// PSIZNVۉNX
/////////////////////////////////////////////////////////////////////////////

class CPsiSection : public CMediaData
{
friend class CPsiSectionParser;

public:
	CPsiSection();
	CPsiSection(const CPsiSection &Operand);

	CPsiSection & operator = (const CPsiSection &Operand);
	const bool operator == (const CPsiSection &Operand);

	const bool ParseHeader(const BYTE *pHexData, const bool bIsExtended = true);
	void Reset(void);

	const BYTE GetTableID(void) const;
	const bool IsExtendedSection(void) const;
	const bool IsPrivate(void) const;
	const WORD GetTableIdExtension(void) const;
	const BYTE GetVersionNo(void) const;
	const bool IsCurrentNext(void) const;
	const BYTE GetSectionNumber(void) const;
	const BYTE GetLastSectionNumber(void) const;

protected:
	struct TAG_PSIHEADER{
		BYTE byTableID;						// e[uID
		bool bSectionSyntaxIndicator;		// ZNVV^bNXCWP[^
		bool bPrivateIndicator;				// vCx[gCWP[^
		WORD wSectionLength;				// ZNV

		WORD wTableIdExtension;				// e[uIDg
		BYTE byVersionNo;					// o[Wԍ
		bool bCurrentNextIndicator;			// JglNXgCWP[^
		BYTE bySectionNumber;				// ZNVԍ
		BYTE byLastSectionNumber;			// XgZNVԍ
		} m_Header;
};


/////////////////////////////////////////////////////////////////////////////
// PSIZNVoNX
/////////////////////////////////////////////////////////////////////////////

class CPsiSectionParser
{
public:
	typedef void (CALLBACK * SECTIONRECVFUNC)(const CPsiSection *pSection, const PVOID pParam);	// ZNV󂯎R[obN^

	CPsiSectionParser();
	CPsiSectionParser(const CPsiSectionParser &Operand);

	CPsiSectionParser & operator = (const CPsiSectionParser &Operand);

	void SetRecvCallback(const bool bTargetExt, const SECTIONRECVFUNC pCallback, const PVOID pParam = NULL);
	void StorePacket(const CTsPacket *pPacket);
	void Reset(void);

	const DWORD GetCrcErrorCount(void) const;

private:
	const BYTE StartUnit(const BYTE *pPayload, const BYTE byRemain);
	const BYTE StoreUnit(const BYTE *pPayload, const BYTE byRemain);

	static const DWORD CalcCrc(const BYTE *pData, const WORD wDataSize, DWORD dwCurCrc = 0xFFFFFFFF);

	SECTIONRECVFUNC m_pfnSectionRecvFunc;
	PVOID m_pCallbackParam;

	bool m_bTargetExt;

	CPsiSection m_PsiSection;

	bool m_bIsStoring;
	DWORD m_dwStoreCrc;
	WORD m_wStoreSize;
	DWORD m_dwCrcErrorCount;
};


#endif // !defined(_TSSTREAM_H_)
